import copy
import emccanon
import recorder
import emccanon
import linuxcnc
from math import atan,sin,cos,tan,degrees,pi,sqrt,floor,ceil
import remap


from interpreter import *
# raises InterpreterException if execute() or read() fails
throw_exceptions = 1


#from stdglue import  init_stdglue

def g01(self,**words):
    words["code"] = "g0"
    recorder.add(words)

def g11(self,**words): 
    words["code"] = "g1"
    recorder.add(words)


def g21(self,**words):
    words["code"] = "g2"
    recorder.add(words)

def g31(self,**words):
    words["code"] = "g3"
    recorder.add(words)

def m200(self,**words):
    profile = int(words["q"])
    recorder.profiles[profile] = list()
    
def m201(self,**words):
    print "m201 words=",words
    profile = int(words["q"])
    print "profile",profile
    print recorder.profiles[profile]

def g71(self,**words):
    c = self.blocks[self.remap_level]
    r = c.r_number if c.r_flag else 0
    p = c.p_number if c.p_flag else 0
    q = int(words["q"])
    profile = int(words["q"])
    start_x = self.current_x
    start_z = self.current_z
    inicio_x = self.current_x  
    radius = 0

    if not  recorder.profiles.has_key(q):
        return "G70: profile %d not defined" % q
   
        

    for cmd in  reversed(recorder.profiles[q]):       
        line = ""
        stmt = copy.deepcopy(cmd)
        line += stmt["code"] + " "
        del stmt["code"]
        lineno = int(stmt["n"])
        del stmt["n"]
        for word in stmt.iterkeys():
            line += word + str(stmt[word]) + " "      
        print "executing %d: %s" % (lineno,line)
        #self.execute(line) 
        #print stmt
        end_x = int(stmt["x"])
        end_z = int(stmt["z"])
        if word is "g2" and "g3":
            radius = int(stmt["r"])
        print end_x   

        rad = radius
        if "g1" in line:
            if "x" in line: 
                while start_x > end_x:
                    if start_x > end_x:
                        start_x = start_x - p                        
                    self.execute("G0 X%f" % start_x)
                    self.execute("G1 Z%f" % end_z)
                    self.execute("G1 X%f" % float(start_x + r) )
                    self.execute("G0 Z%f" % start_z)
                    lineno += 1   
        
        elif "g2" in line:
            if "r" in line:
                while start_x > end_x:
                    if start_x > end_x:
                        start_x = start_x - p         
                        cat1 = abs((end_x+rad)-start_x)
                        cat2 = abs(radius**2 - cat1**2)
                        cateto = abs(sqrt(cat2)) 
                    self.execute("G0 X%f" % start_x)
                    self.execute("G1 Z%f" % float(end_z + rad - cateto))
                    self.execute("G1 X%f" % float(start_x + r))
                    self.execute("G0 Z%f" % start_z) 
                    lineno += 1     
       
    self.execute("g0 x%f" % inicio_x)             
    recorder.profiles[profile] = list() 
    return INTERP_OK



def g12(self, **words):
    c = self.blocks[self.remap_level]
    x = c.x_number if c.x_flag else 0 
    z = c.z_number if c.z_flag else 0
    p = c.p_number if c.p_flag else 0
    i = c.i_number if c.i_flag else 0
    k = c.k_number if c.k_flag else 0
    b = c.b_number if c.b_flag else 0
    r = c.r_number if c.r_flag else 0
    j = c.j_number if c.j_flag else 0  
    start_x = self.current_x
    start_z = self.current_z
    inicio_x = self.current_x 
    inicio_z = self.current_z
    x_final = x 
    z_final = z
    x_nom = self.current_x
    cat1 = abs((x+j)-start_x)
    cat2 = abs(j**2 - cat1**2)


    if p == 0:
        return "Not found depth cutter"    

     
    
    self.execute("G0 Z%f" % (start_z))
    end_z = z
    if start_x > x:
        if j >= 0:    
            while start_x > x:
                if  start_x > x+j:
                    start_x = (start_x - p)
                    cat1 = abs((x+j)-start_x)
                    cat2 = abs(j**2 - cat1**2)
                    cateto = abs(sqrt(cat2)) 
                elif start_x <= x+j and start_x > x:
                    start_x = abs(start_x - p)
                    cat1 = abs((x+j)-start_x)
                    cat2 = abs(j**2 - cat1**2)
                    cateto = abs(sqrt(cat2))                     
                self.execute("G0 X%f" % (2*start_x+i))
                self.execute("G0 Z%f" % (start_z))
                if start_x > x + j:
                    self.execute("G1 Z%f" % (z+k))
                elif start_x <= x+j and start_x >= x:
                    self.execute("G1 Z%f" % (end_z + j - cateto + k))                    
                self.execute("G1 X%f" % (2*start_x + p+ i))
                self.execute("G0 Z%f" % (start_z))
        else:
             while start_x > x:
                 if start_x > x:
                     start_x = start_x - p            
                 self.execute("G0 X%f" % (2*start_x+i))
                 self.execute("G0 Z%f" % (start_z))
                 self.execute("G1 Z%f" % (end_z+k))
                 self.execute("G0 X%f" % (2*start_x+p))
                 self.execute("G0 Z%f" % (start_z))       
        self.execute("G0 X%f" % (2*x-(r*2)))
        self.execute("G1 Z%f" % (inicio_z))
        self.execute("G1 X%f Z%f" % (2*x+i,(inicio_z-r)))
        if j > 0:
            self.execute("G1 Z%f" % (z+j+k))
            self.execute("G2 X%f Z%f R%f" % (2*x+i+2*j,(z+k),j))
        else:
            self.execute("G01 Z%f" % (z+k))        
        self.execute("G1 X%f" % (2*inicio_x))
        self.execute("G0 Z%f" % (start_z))
           
    else:
        while (start_x < x): 
            if (start_x  < x-j):
                start_x = start_x + p
                cat1 = abs((x-j)-start_x)
                cat2 = abs(j**2 - cat1**2)
                cateto = abs(sqrt(cat2)) 
            elif start_x < x:
                start_x = start_x + p
                cat1 = abs((x-j)-start_x)
                cat2 = abs(j**2 - cat1**2)
                cateto = abs(sqrt(cat2))
            self.execute("G0 X%f" % (2*start_x))
            self.execute("G0 Z%f" % (start_z))       
            if start_x < x - j:
                self.execute("G1 Z%f" % (z))
            elif start_x >= x-j and start_x < x:
                self.execute("G1 Z%f" % (end_z + j - cateto))     
            self.execute("G1 X%f" % (2*start_x-p))
            self.execute("G0 Z%f" % (start_z))
        self.execute("G0 X%f" % (2*x_final+r))
        self.execute("G1 Z%f" % (inicio_z))
        self.execute("G1 X%f Z%f" % (2*x,(inicio_z-r)))
        if j > 0:           
            self.execute("G1 Z%f" % (z+j))
            self.execute("G3 X%f Z%f R%f" % (2*x-2*j,(z),j))
        else:
            self.execute("G1 Z%f" % (z))   
        self.execute("G1 X%f" % (2*inicio_x))
        self.execute("G0 Z%f" % (start_z))            
    return INTERP_OK

def g13(self,**words):
    c = self.blocks[self.remap_level]
    x = c.x_number if c.x_flag else 0 
    z = c.z_number if c.z_flag else 0
    xf = c.p_number if c.p_flag else 0 
    zf = c.q_number if c.q_flag else 0
    r = c.r_number if c.r_flag else 0
    i = c.i_number if c.i_flag else 0
    k = c.k_number if c.k_flag else 0
    start_x = self.current_x
    start_z = self.current_z
    ini_x = x
    ini_z = z
    fin_x = xf
    fin_z = zf   

  
    if r == 0:
        return "No hay profundidad de corte"
    
    if xf != x:         
        xalf = float(x-xf)
        xalf2 = abs(xalf / 2) 
        zalf = float(z-zf)
        zalf2 = abs(zalf)
        alf = atan(zalf2 / xalf2)
        alfa = degrees(alf) 
    else:
        alfa = 90    
    
     
    
    while (start_x > x):
        zact = start_z+2
        ang = (zalf2/xalf2)     
        if start_x - r > x:
            start_x = start_x - r
            cady = (start_x-x)/2   
            zact = -ang * cady
        else:
            start_x = x
        self.execute("G0 X%f" % (start_x+i))
        self.execute("G1 Z%f" % (zact+k))
        self.execute("G1 X%f" % float(start_x+0.39))
        self.execute("G0 Z%f" % z)              
    self.execute("G0 X%f" % ini_x)
    self.execute("G0 Z%f" % ini_z)
    self.execute("G1 X%f Z%f" % (fin_x,fin_z)) 
    self.execute("G0 Z%f" % ini_z) 
    return INTERP_OK
    
def g14(self,**words):
    c = self.blocks[self.remap_level]
    x = c.x_number if c.x_flag else 0 
    z = c.z_number if c.z_flag else 0
    p = c.p_number if c.p_flag else 0
    i = c.i_number if c.i_flag else 0
    k = c.k_number if c.k_flag else 0
    
    start_x = self.current_x
    start_z = self.current_z
    inicio_z = self.current_z 
   
    
    if p == 0:
        return "No hay profundidad de corte"    
   
    
    while (start_z > z):
        if (start_z-p > z):
            start_z = start_z-p
        else:
            start_z = z
        self.execute("G0 Z%f" % (start_z+k))
        self.execute("G1 X%f" % (2*x))
        self.execute("G1 Z%f" % (start_z+0.5))
        self.execute("G0 X%f" % (2*start_x))
    self.execute("G0 Z%f" % (inicio_z))      
    return INTERP_OK                
        
    
def g761(self,**words):
    c = self.blocks[self.remap_level]
    x = c.x_number if c.x_flag else 0  #diametro max/min dependiendo si es rosca interna o externa.
    z = c.z_number if c.z_flag else 0  #logitud de la rosca
    p = c.p_number if c.p_flag else 0  #paso de la rosca
    q = c.q_number if c.q_flag else 0  #profundidad por pasada
    r = c.r_number if c.r_flag else 3  # retroceso
    #u = c.u_number if c.u_flag else 3  # Numero de repeticiones de acabado 
    start_x = self.current_x
    start_z = self.current_z
    inicio_x = self.current_x-3
    constante = 0.026185921
    end_x =float(constante * z)
    
   
    if start_x > x:
        while start_x > x:
            if start_x - q > x:
                start_x = start_x - q
                xf = xf - q
            else:
                start_x = x
                xf = xf - q               
            self.execute("G0 X%f" % (2*start_x))
            self.execute("G33 X%f Z%f K%f" % (2*xf,z,p))
            self.execute("G0 X%f" % (2*inicio_x+r))
            self.execute("G0 Z%f" % (start_z))
    else:
        while start_x < x:
            if start_x + q < x:
                start_x = start_x + q
            else:
                start_x = x                          
            self.execute("G0 X%f" % (2*start_x))
            self.execute("G33 X%f Z%f K%f" % (2*(start_x+end_x),z,p))                  
            self.execute("G0 X%f" % (2*inicio_x))
            self.execute("G0 Z%f" % (start_z))
    for r in range(1,r):
        self.execute("G0 X%f" % (2*start_x))
        self.execute("G33 X%f Z%f K%f" % (2*(start_x+end_x),z,p))                  
        self.execute("G0 X%f" % (2*inicio_x))
        self.execute("G0 Z%f" % (start_z))                  
    return INTERP_OK
             
            


    
      
    


